import { createVNode as _createVNode } from "vue";
// Styles
import "./VLabel.css";

// Composables
import { makeThemeProps } from "../../composables/theme.mjs"; // Utilities
import { defineComponent, useRender } from "../../util/index.mjs";
export const VLabel = defineComponent({
  name: 'VLabel',
  props: {
    text: String,
    clickable: Boolean,
    ...makeThemeProps()
  },
  setup(props, _ref) {
    let {
      slots
    } = _ref;
    useRender(() => {
      var _slots$default;
      return _createVNode("label", {
        "class": ['v-label', {
          'v-label--clickable': props.clickable
        }]
      }, [props.text, (_slots$default = slots.default) == null ? void 0 : _slots$default.call(slots)]);
    });
    return {};
  }
});
//# sourceMappingURL=VLabel.mjs.map